//
// Arduino Nano chargé de déterminer la position horizontale du chariot (grace à l'encodeur rotatif de son moteur)
//
// Type de carte : Arduino Nano
// Processor : ATmega328P (Old Bootloader)
// COM5
//
#include <Wire.h>
#include "src/PololuWheelEncoders/PololuWheelEncoders.h"  // répertoire "src" obligatoire pour que cet include fonctionne

#define ADR_ARDUINO_XCHARIOT 8   // Adresse I2C de l'arduino nano "XChariot"

int xChariot=0;
byte arrayI2C[2];

void setup() {
  Serial.begin(115200);
  pinMode(4, INPUT);
  pinMode(5, INPUT);
  encoders_init(2, 3, 4, 5);
  Wire.begin(ADR_ARDUINO_XCHARIOT);
  Wire.onRequest(requestEvent); // L'arduino principal a fait une demande
  Wire.onReceive(receiveEvent);
}

// L'arduino principal a fait une demande
void requestEvent() {
  arrayI2C[0] = (xChariot >> 8) & 0xFF; // codage de l'angle sur 2 octets
  arrayI2C[1] = xChariot & 0xFF;
  Wire.write(arrayI2C, 2);    // envoi des 2 octets à l'Arduino principal
}

void receiveEvent(int howMany) {
  while(Wire.available()) {
    char c = Wire.read();
    if (c=='0') xChariot=encoders_get_counts_and_reset_m2();
  }
}

void loop() {
    xChariot=encoders_get_counts_m2();
    if(encoders_check_error_m2()) Serial.print("Error m2");
    delay(5);
}
